#include <Servo.h>
Servo monServo; // librairie du servomoteur

//Le moteur est controllé par un composant L293D, il nécessite 
//2 broches pour faire tourner le moteur dans les 2 sens 
// + une broche PWM qui permet de faire varier la vitesse du moteur
const int pin1 = 2;
const int vitesse = 3;
const int pin3 = 4; 


#define echoPin 12 // broche Echo Pin du capteur à ultrasons
#define trigPin 13 // broche Trigger Pin du capteur à ultrasons

//durée du signal à ultrasons
int maximumRange = 200; 
int minimumRange = 0; 
long duration, distance; 
 

void setup(){

  pinMode(pin1, OUTPUT);
  pinMode(vitesse, OUTPUT);
  pinMode(pin3, OUTPUT);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  monServo.attach(7, 1000, 2000);
  
}  


void loop() {
  
 // Le cycle trigPin/echoPin est utilisé pour déterminer la distance 
 // à un objet en lui envoyant des ultrasons
 digitalWrite(trigPin, LOW); 
 delayMicroseconds(2); 

 digitalWrite(trigPin, HIGH);
 delayMicroseconds(10); 
 
 digitalWrite(trigPin, LOW);
 duration = pulseIn(echoPin, HIGH);
 
 //Calcule la distance (en cm) sur la base de la vitesse du son
 distance = duration/58.2;
 
  // le capteur a ultrasons HC-SR04 semble être performant 
  // entre 0 et 50 cm 
  if (distance < 30) 
  {
    // Arrêt du moteur
    digitalWrite(pin1, LOW);
    digitalWrite(pin3, LOW);
    delay(2500);
    
    // Tourner à droite: 100 + 13° 
    monServo.write(113); 
    delay(100);
    
    // Marche arrière
    digitalWrite(pin1, HIGH);
    digitalWrite(pin3, LOW);
    analogWrite( vitesse, 180);
    delay(1500);
    
    // Tourner à gauche: 100 - 13° 
    monServo.write(87); 
    delay(100);
  }
  
  else
  {
    // Aller tout droit
    monServo.write(100); // 100 est l'origine que j'ai fixé 100 = 90°théorique
    delay(100);
    
    // Marche avant
    digitalWrite(pin1, LOW);
    digitalWrite(pin3, HIGH);
    analogWrite( vitesse, 255); 
    
  }
   
}
